import pytest

from gcs_migration.typing.auth_documents import (
    IdentityDocumentDict,
    IdentityProviderDocumentDict,
)


@pytest.fixture
def identity_provider_document() -> IdentityProviderDocumentDict:
    return {
        "id": "d51f5c44-a53b-4d47-ac95-283a4a4643f5",
        "name": "Globus Staff",
        "short_name": "globus.org",
        "alternative_names": [],
        "domains": ["globus.org"],
    }


@pytest.fixture
def identity_document(
    identity_provider_document: IdentityProviderDocumentDict,
) -> IdentityDocumentDict:
    return {
        "username": "user@globus.org",
        "status": "used",
        "name": "User Document",
        "id": "64620d3a-f6d6-4e56-9b48-a73b3ac5f070",
        "organization": "Globus",
        "email": "user_email@globus.org",
        "identity_type": "login",
        "identity_provider": "f{identity_provider_document['id']}",
    }


@pytest.fixture
def email_idp_identity_document() -> IdentityDocumentDict:
    return {
        "username": "user@email.org",
        "status": "used",
        "name": "Email User Document",
        "id": "945247fb-a748-4cac-9c52-2c81ec05582a",
        "identity_type": "email",
        "organization": "Globus",
        "email": "user_email@globus.org",
        "identity_provider": "7daddf46-70c5-45ee-9f0f-7244fe7c8707",
    }


@pytest.fixture
def unused_idp_identity_document(
    identity_provider_document: IdentityProviderDocumentDict,
) -> IdentityDocumentDict:
    return {
        "username": "user@email.org",
        "status": "closed",
        "name": "Closed User Document",
        "id": "5a692aaa-c14b-4cb2-b8b0-b23721963693",
        "identity_type": "login",
        "organization": "Globus",
        "email": "closed_user_email@globus.org",
        "identity_provider": "f{identity_provider_document['id']}",
    }
